%define name clanlib0.7
%define version	0.7.8
%define release 1.1mdk
%define prefix %{_prefix}
%define lib_name_orig libclanlib
%define lib_major 3
%define lib_name %{lib_name_orig}%{lib_major}

Name: %{name}
Summary: The ClanLib Game SDK
Version: %{version}
Release: %{release}
License: LGPL
Group: System/Libraries
Source: http://dark.x.dtu.dk/~mbn/clanlib/download/download-sphair/ClanLib-%{version}.tar.bz2
URL: http://clanlib.org/
Packager: Pablo Castorino  <csp@castorinop.com.ar>
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires:  libmikmod-devel libpng-devel Mesa-common-devel bzip2 libjpeg-devel 
BuildRequires:  libtiff-devel XFree86-static-libs libbzip2-devel libvorbis-devel libogg-devel freetype2-devel
BuildConflicts:	OpenPTC-devel
Obsoletes: ClanLib
Provides: ClanLib = %{version}-%{release}

%description
The ClanLib Game SDK is a crossplatform game library designed to ease the work
for game developers. The goal is to provide a common interface to classical
game problems (loading graphics eg.), so games can share as much code as
possible. Ideally anyone with small resources should be able to write
commercial quality games.

%package -n %{lib_name}
Summary: Main library for %{name}
Group: System/Libraries

%description -n %{lib_name}
This package contains the library needed to run programs dynamically
linked with %{name}.

%package -n %{lib_name}-devel
Summary: Headers for developing programs that will use %{name}
Group: Development/C++
Requires: %{lib_name} = %{version}
Provides: %{lib_name_orig}-devel = %{version}-%{release}
Obsoletes: ClanLib-devel clanlib-devel
Provides: ClanLib-devel = %{version}-%{release} clanlib-devel = %{version}-%{release}

%description -n %{lib_name}-devel
This package contains the headers that programmers will need to develop
applications which will use %{name}.

%package -n %{lib_name}-static-devel
Summary: Static libraries for %{name}
Group: Development/C++
Requires: %{lib_name} = %{version}
Provides: %{lib_name_orig}-static-devel = %{version}-%{release}
Obsoletes: ClanLib-static-devel clanlib-static-devel
Provides: ClanLib-devel = %{version}-%{release} clanlib-devel = %{version}-%{release}
                                                                                                                                             
%description -n %{lib_name}-static-devel
This package contains the static libraries for %{name}.

#%package -n %{lib_name}-display2
#Summary: ClanLib Display2 module
#Group: System/Libraries
#Requires: %{lib_name} = %{version} Mesa
#BuildRequires: Mesa-common-devel

#%description -n %{lib_name}-display2
#The ClanLib Game SDK is a crossplatform game library designed to ease the
#work for game developers. This package is the Display2 module (clanDisplay2).

#%package -n %{lib_name}-gl
#Summary: ClanLib OpenGL module
#Group: System/Libraries
#Requires: %{lib_name} = %{version} Mesa
#BuildRequires: Mesa-common-devel

#%description -n %{lib_name}-gl
#The ClanLib Game SDK is a crossplatform game library designed to ease the
#work for game developers. This package is the OpenGL module (clanGL).

%package -n %{lib_name}-sound
Summary: ClanLib Sound module
Group: System/Libraries
Requires: %{lib_name} = %{version}

%description -n %{lib_name}-sound
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package is the Sound module (clanSound).

%package -n %{lib_name}-vorbis
Summary: ClanLib Vorbis module
Group: System/Libraries
Requires: %{lib_name} = %{version}

%description -n %{lib_name}-vorbis
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package is the Vorbis module (clanVorbis).

%package -n %{lib_name}-network
Summary: ClanLib Network module
Group: System/Libraries
Requires: %{lib_name} = %{version}

%description -n %{lib_name}-network
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package is the Network module (clanNetwork).

%package -n %{lib_name}-gui
Summary: ClanLib Gui module
Group: System/Libraries
Requires: %{lib_name} = %{version}

%description -n %{lib_name}-gui
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package is the Gui module (clanGUI).

#%package -n %{lib_name}-ttf
#Summary: ClanLib TTF module
#Group: System/Libraries
#Requires: %{lib_name} = %{version}

#%description -n %{lib_name}-ttf
#The ClanLib Game SDK is a crossplatform game library designed to ease the
#work for game developers. This package is the TTF module (clanTTF).

%package -n %{lib_name}-mikmod
Summary: ClanLib MikMod module
Group: System/Libraries
Requires: %{lib_name} = %{version}
Obsoletes: ClanLib-mikmod clanlib-mikmod
Provides: ClanLib-mikmod = %{version}-%{release} clanlib-mikmod = %{version}-%{release}

%description -n %{lib_name}-mikmod
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package is the MikMod module (clanMikMod).

%package docs
Summary: ClanLib documentation
Group: System/Libraries
Obsoletes: ClanLib-docs clanlib-docs
Provides: ClanLib-docs = %{version}-%{release} clanlib-docs = %{version}-%{release}

%description docs
The ClanLib Game SDK is a crossplatform game library designed to ease the
work for game developers. This package contains the documentation.

%prep
%setup -D -q -n ClanLib-%{version}
# -D is to not delete BUILD dir before untarring

%build
# (sb) doesn't build on PPC with this
%ifnarch ppc
# (gc) workaround g++ exception bug when -fomit-frame-pointer is set
export CFLAGS="$RPM_OPT_FLAGS -fno-omit-frame-pointer" CXXFLAGS="$RPM_OPT_FLAGS -fno-omit-frame-pointer"
%endif
#export WANT_AUTOCONF_2_5=1
./autogen.sh
%ifarch %{ix86}
  %configure --enable-dyn
%else
  # (sb) configure macro breaks PPC build - just do it manually for now
  %ifnarch ppc
    %configure --enable-dyn --disable-asm386
  %else
    libtoolize --copy --force
    ./configure --enable-dyn --disable-asm386  
  %endif
%endif
make all
#make strip
#make docs

%install
%makeinstall BIN_PREFIX=$RPM_BUILD_ROOT%{_bindir} LIB_PREFIX=$RPM_BUILD_ROOT%{_libdir} INC_PREFIX=$RPM_BUILD_ROOT%{_includedir} TARGET_PREFIX=$RPM_BUILD_ROOT%{_libdir}/ClanLib
#make MAN_PREFIX=$RPM_BUILD_ROOT%{_mandir} HTML_PREFIX=$RPM_BUILD_ROOT%{_datadir}/doc/%{name}-docs-%{version}/Docs docs_install

%post -n %{lib_name} -p /sbin/ldconfig
#%post -n %{lib_name}-display2 -p /sbin/ldconfig
#%post -n %{lib_name}-gl -p /sbin/ldconfig
%post -n %{lib_name}-mikmod -p /sbin/ldconfig
%post -n %{lib_name}-sound -p /sbin/ldconfig
%post -n %{lib_name}-vorbis -p /sbin/ldconfig
%post -n %{lib_name}-network -p /sbin/ldconfig
%post -n %{lib_name}-gui -p /sbin/ldconfig
#%post -n %{lib_name}-ttf -p /sbin/ldconfig

%postun -n %{lib_name} -p /sbin/ldconfig
#%postun -n %{lib_name}-display2 -p /sbin/ldconfig
#%postun -n %{lib_name}-gl -p /sbin/ldconfig
%postun	-n %{lib_name}-mikmod -p /sbin/ldconfig
%postun -n %{lib_name}-sound -p /sbin/ldconfig
%postun -n %{lib_name}-vorbis -p /sbin/ldconfig
%postun -n %{lib_name}-network -p /sbin/ldconfig
%postun -n %{lib_name}-gui -p /sbin/ldconfig
#%postun -n %{lib_name}-ttf -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT
#don't clean up build root for now

%files -n %{lib_name}
%defattr(-, root, root)
%doc README COPYING CREDITS
%{_libdir}/libclanCore*.so*
%{_libdir}/libclanApp*.so*
%{_libdir}/libclanDisplay*.so*

%files -n %{lib_name}-devel
%defattr(-, root, root)
%doc README COPYING CODING_STYLE ascii-logo NEWS
%{_libdir}/*.so*
%{_libdir}/pkgconfig/*
%{_includedir}/ClanLib-0.7/*
#%{_bindir}/clanlib-config

%files -n %{lib_name}-static-devel
%defattr(-, root, root)
%doc README
%{_libdir}/*.a
%{_libdir}/*.la

%files docs
%defattr(0644,root,root,0755)
#%{_docdir}/%{name}-docs-%{version}/*
%doc %{_docdir}/clanlib/*

#%files -n %{lib_name}-display2
#%defattr(-, root, root)
#%doc README COPYING
#%{_libdir}/libclanDisplay2.so.*

#%files -n %{lib_name}-gl
#%defattr(-, root, root)
#%doc README COPYING
#%{_libdir}/libclanGL*.so*

%files -n %{lib_name}-mikmod
%defattr(-, root, root)
%doc README COPYING 
%{_libdir}/libclanMikMod*.so*

#%files -n %{lib_name}-png
#%defattr(-, root, root)
#%doc README COPYING 
#%{_libdir}/libclanPNG*.so*

#%files -n %{lib_name}-ttf
#%defattr(-, root, root)
#%doc README COPYING 
#%{_libdir}/libclanTTF*.so*

#%files -n %{lib_name}-jpeg
#%defattr(-, root, root)
#%doc README COPYING 
#%{_libdir}/libclanJPEG*.so*

%files -n %{lib_name}-network
%defattr(-, root, root)
%doc README COPYING 
%{_libdir}/libclanNetwork*.so*

%files -n %{lib_name}-vorbis
%defattr(-, root, root)
%doc README COPYING 
%{_libdir}/libclanVorbis*.so*

#%files -n %{lib_name}-smalljpeg
#%defattr(-, root, root)
#%doc README COPYING 
#%{_libdir}/libclanSmallJPEG*so.*

%files -n %{lib_name}-sound
%defattr(-, root, root)
%{prefix}/lib/libclanSound*.so*

%files -n %{lib_name}-gui
%defattr(-, root, root)
%{prefix}/lib/libclanGUI*.so*

#%files mpeg
#%defattr(-, root, root)
#%{prefix}/lib/libclanMPEG.so*

%changelog
* Sun Apr 11 2004 Pablo Castorino <csp@castorinop.com.ar>
- Update Clanlib 0.7.8

* Sat Apr 03 2004 Pablo Castorino <csp@castorinop.com.ar>
- Update ClanLib 0.7.7 spec

* Sun Apr 07 2002 Jeroen Janssen <japj@clanlib.org>
- initial 0.7.0 spec
