/*  $Id: zip_64_end_of_central_directory_locator.h,v 1.4 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_zip_64_end_of_central_directory_locator
#define header_zip_64_end_of_central_directory_locator

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/IOData/datatypes.h"

class CL_InputSource;
class CL_OutputSource;

class CL_Zip_64EndOfCentralDirectoryLocator
{
//! Construction:
public:
	CL_Zip_64EndOfCentralDirectoryLocator();
	
	~CL_Zip_64EndOfCentralDirectoryLocator();
	
//! Attributes:
public:
	cl_int32 signature; // 0x07064b50

	cl_int32 number_of_disk_with_zip64_end_of_central_directory;

	cl_int64 relative_offset_of_zip64_end_of_central_directory;

	cl_int32 total_number_of_disks;

//! Operations:
public:
	void load(CL_InputSource *input);
	
	void save(CL_OutputSource *output);

//! Implementation:
private:
};

#endif
