/*  $Id: zip_end_of_central_directory_record.h,v 1.5 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_zip_end_of_central_directory_record
#define header_zip_end_of_central_directory_record

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/IOData/datatypes.h"

class CL_InputSource;
class CL_OutputSource;

class CL_Zip_EndOfCentralDirectoryRecord
{
//! Construction:
public:
	CL_Zip_EndOfCentralDirectoryRecord();
	
	~CL_Zip_EndOfCentralDirectoryRecord();
	
//! Attributes:
public:
	cl_int32 signature; // 0x06054b50

	cl_int16 number_of_this_disk;

	cl_int16 number_of_disk_with_start_of_central_directory;

	cl_int16 number_of_entries_on_this_disk;

	cl_int16 number_of_entries_in_central_directory;

	cl_int32 size_of_central_directory;

	cl_int32 offset_to_start_of_central_directory;

	cl_int16 file_comment_length;

	std::string file_comment;

//! Operations:
public:
	void load(CL_InputSource *input);
	
	void save(CL_OutputSource *output);

//! Implementation:
private:
};

#endif
