/*  $Id: zip_file_entry_generic.h,v 1.6 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_zip_file_entry_generic
#define header_zip_file_entry_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/IOData/datatypes.h"
#include "zip_file_header.h"

class CL_Zip_FileEntry_Generic
{
//! Attributes:
public:
	//: Zip file entry type enum.
	enum Type
	{
		type_file,
		type_removed,
		type_added_memory,
		type_added_file
	};
	
	//: Central directory record attributes for entry:
	CL_Zip_FileHeader record;

	//: File entry type.
	Type type;
	
	//: Offset to zip data in zip file (type_file).
	// cl_int64 offset;

	//: Filename of file, if added from file (type_added_file).
	std::string filename;
	
	//: Data of zip file entry, if added from memory (type_added_memory).
	std::string data;
};

#endif
