/*  $Id: zip_flags.h,v 1.2 2003/07/20 22:30:53 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef zip_flags
#define zip_flags

// Version from which Zip64 was introduced
#define CL_ZIP_64Version 45

// General purpose flags:
#define CL_ZIP_ENCRYPTED                        1

#define CL_ZIP_IMPLODE_8K_SLIDING_DICT          2
#define CL_ZIP_IMPLODE_3_SHANNON_FANO_TREES     4

#define CL_ZIP_DEFLATE_COMPRESS_MAXIMUM         2
#define CL_ZIP_DEFLATE_COMPRESS_FAST            4
#define CL_ZIP_DEFLATE_COMPRESS_SUPER_FAST      6

#define CL_ZIP_CRC32_IN_FILE_DESCRIPTOR         8
#define CL_ZIP_DEFLATE64_RESERVED              16
#define CL_ZIP_FILE_IS_COMPRESSED_PATCHED_DATA 32

// CRC-32 properties:

#define CL_ZIP_CRC_MAGIC_NUMBER 0xdebb20e3
#define CL_ZIP_CRC_START_VALUE 0xffffffff

// File attributes:

#define CL_ZIP_FILE_ATTR_TEXT 1

#endif
