/*  $Id: zip_local_file_descriptor.cpp,v 1.4 2003/07/20 22:30:53 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Core/precomp.h"
#include "zip_local_file_descriptor.h"
#include "API/Core/IOData/inputsource.h"
#include "API/Core/IOData/outputsource.h"

/////////////////////////////////////////////////////////////////////////////
// CL_Zip_LocalFileDescriptor construction:

CL_Zip_LocalFileDescriptor::CL_Zip_LocalFileDescriptor()
{
}
	
CL_Zip_LocalFileDescriptor::~CL_Zip_LocalFileDescriptor()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_Zip_LocalFileDescriptor attributes:


/////////////////////////////////////////////////////////////////////////////
// CL_Zip_LocalFileDescriptor operations:

void CL_Zip_LocalFileDescriptor::load(CL_InputSource *input)
{
	crc32 = input->read_int32();
	compressed_size = input->read_int32();
	uncompressed_size = input->read_int32();
}
	
void CL_Zip_LocalFileDescriptor::save(CL_OutputSource *output)
{
	output->write_int32(crc32);
	output->write_int32(compressed_size);
	output->write_int32(uncompressed_size);
}
	
/////////////////////////////////////////////////////////////////////////////
// CL_Zip_LocalFileDescriptor implementation:
