/*  $Id: zip_local_file_header.h,v 1.4 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_zip_local_file_header
#define header_zip_local_file_header

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/IOData/datatypes.h"

class CL_InputSource;
class CL_OutputSource;

class CL_Zip_LocalFileHeader
{
//! Construction:
public:
	CL_Zip_LocalFileHeader();
	
	~CL_Zip_LocalFileHeader();

//! Attributes:
public:
	cl_int32 signature; // 0x04034b50

	cl_int16 version_needed_to_extract;

	cl_int16 general_purpose_bit_flag;

	cl_int16 compression_method;

	cl_int16 last_mod_file_time;

	cl_int16 last_mod_file_date;

	cl_int32 crc32;

	cl_int32 compressed_size;

	cl_int32 uncompressed_size;

	cl_int16 file_name_length;

	cl_int16 extra_field_length;

	std::string filename;

	std::string extra_field;
	
//! Operations:
public:
	void load(CL_InputSource *input);
	
	void save(CL_OutputSource *output);
	
//! Implementation:
private:
};

#endif
