/*  $Id: delauney_triangulator_generic.h,v 1.2 2004/04/07 21:43:51 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_delauney_triangulator_generic
#define header_delauney_triangulator_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/Math/delauney_triangulator.h"

class CL_DelauneyTriangulator_Generic
{
//! Construction:
public:
	CL_DelauneyTriangulator_Generic();

	~CL_DelauneyTriangulator_Generic();

//! Attributes:
public:
	std::vector<CL_DelauneyTriangulator_Vertex> input_vertices;

	std::vector<CL_DelauneyTriangulator_Triangle> triangles;

//! Operations:
public:
	void triangulate();

	void create_ordered_vertex_list(
		std::vector<CL_DelauneyTriangulator_Vertex *> &vertices);

	void calculate_supertriangle(
		std::vector<CL_DelauneyTriangulator_Vertex *> &vertices,
		CL_DelauneyTriangulator_Triangle &super_triangle);

	void perform_delauney_triangulation(
		const std::vector<CL_DelauneyTriangulator_Vertex *> &vertices,
		const CL_DelauneyTriangulator_Triangle &super_triangle,
		std::vector<CL_DelauneyTriangulator_Triangle> &triangles);

	CL_DelauneyTriangulator_Vertex find_circumcenter(
		const CL_DelauneyTriangulator_Triangle &triangle);
};

#endif
