/*  $Id: resource_generic.cpp,v 1.4 2004/02/01 01:54:16 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Core/precomp.h"
#include "resource_generic.h"
#include "API/Core/Resources/resourcedata.h"

/////////////////////////////////////////////////////////////////////////////
// CL_Resource_Generic construction:

CL_Resource_Generic::CL_Resource_Generic(
	CL_DomElement &element,
	const CL_WeakPtr<CL_ResourceManager_Generic> &manager)
: load_ref(0), manager(manager), element(element)
{
}

CL_Resource_Generic::~CL_Resource_Generic()
{
	std::map<std::string, CL_ResourceData*>::iterator it;
	for (it = datas.begin(); it != datas.end(); ++it)
	{
		delete it->second;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CL_Resource_Generic attributes:

/////////////////////////////////////////////////////////////////////////////
// CL_Resource_Generic operations:

/////////////////////////////////////////////////////////////////////////////
// CL_Resource_Generic implementation:
