/*  $Id: resourcedata.cpp,v 1.4 2004/02/01 01:54:16 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Core/precomp.h"
#include "API/Core/Resources/resourcedata.h"
#include "API/Core/System/weakptr.h"

/////////////////////////////////////////////////////////////////////////////
// CL_ResourceData_Generic:

class CL_ResourceData_Generic
{
public:
	CL_WeakPtr<CL_Resource_Generic> resource;
};

/////////////////////////////////////////////////////////////////////////////
// CL_ResourceData construction:

CL_ResourceData::CL_ResourceData(CL_Resource &resource)
: impl(new CL_ResourceData_Generic)
{
	impl->resource = resource.impl;
}

CL_ResourceData::~CL_ResourceData()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_ResourceData attributes:

CL_Resource CL_ResourceData::get_resource()
{
	return CL_Resource(impl->resource);
}

/////////////////////////////////////////////////////////////////////////////
// CL_ResourceData implementation:
