/*  $Id: call_stack.cpp,v 1.2 2004/02/01 03:07:16 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Core/precomp.h"
#include "API/Core/System/call_stack.h"
#include "call_stack_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_CallStack Construction:

CL_CallStack::CL_CallStack() : impl(new CL_CallStack_Generic)
{
}

CL_CallStack::~CL_CallStack()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_CallStack Attributes:

int CL_CallStack::get_num_frames() const
{
	return impl->frames.size();
}

const std::string &CL_CallStack::get_call_frame(int frame) const
{
	return impl->frames[frame];
}

/////////////////////////////////////////////////////////////////////////////
// CL_CallStack Operations:

void CL_CallStack::add_call_frame(const std::string &str_frame)
{
	impl->frames.push_back(str_frame);
}

/////////////////////////////////////////////////////////////////////////////
// CL_CallStack Implementation:
