/*  $Id: console_window_generic.h,v 1.12 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_console_window_generic
#define header_console_window_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <string>
#include <cstdio>

class CL_ConsoleWindow_Generic
{
//! Construction:
public:
	CL_ConsoleWindow_Generic(
		const std::string &title,
		int width,
		int height);

	~CL_ConsoleWindow_Generic();

//! Operations:
public:
	void redirect_stdio();

	void redirect_stdio(const std::string &file);

	void wait_for_key();
	void display_close_message();

//! Implementation:
private:
	void close_file_handles();

#ifdef _MSC_VER
	FILE *fstdout;
	FILE *fstdin;
	FILE *fstderr;
#else
	std::FILE *fstdout;
	std::FILE *fstdin;
	std::FILE *fstderr;
#endif
};

#endif
