/*  $Id: log.cpp,v 1.4 2003/09/09 20:31:51 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Core/precomp.h"
#include "API/Core/System/log.h"

/////////////////////////////////////////////////////////////////////////////
// CL_Log construction:


/////////////////////////////////////////////////////////////////////////////
// CL_Log attributes:

static CL_Signal_v3<const std::string &, int, const std::string &> cl_sig_log;

CL_Signal_v3<const std::string &, int, const std::string &> &CL_Log::sig_log()
{
	return cl_sig_log;
}

/////////////////////////////////////////////////////////////////////////////
// CL_Log operations:

void CL_Log::log(const std::string &group, const std::string &message)
{
	cl_sig_log(group, 0, message);
}

void CL_Log::log(const std::string &group, int severity, const std::string &message)
{
	cl_sig_log(group, severity, message);
}

/////////////////////////////////////////////////////////////////////////////
// CL_Log implementation:
