/*  $Id: event_trigger_unix.h,v 1.5 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_event_trigger_unix
#define header_event_trigger_unix

#if _MSC_VER > 1000
#pragma once
#endif

#include "../Generic/event_trigger_generic.h"

class CL_EventTrigger_Unix : public CL_EventTrigger_Generic
{
//! Construction:
public:
	CL_EventTrigger_Unix();

	virtual ~CL_EventTrigger_Unix();

//! Attributes:
public:
	virtual bool get_flag() const;

//! Operations:
public:
	//: Reset trigger flag.
	virtual void reset() const;

	//: Raise trigger flag.
	virtual void set_flag();

	//: Wait until one of the event triggers. The timeout is in milliseconds.
	//return: true if the event triggered, false if it timed out.
	virtual bool wait(int timeout = -1) const;

//! Implementation:
public:
	// Waiting pipe.
	int wait_pipe[2];
};

#endif
