/*  $Id: dom_document_type.cpp,v 1.8 2004/02/01 04:31:55 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Core/precomp.h"
#include "API/Core/XML/dom_document_type.h"
#include "API/Core/XML/dom_named_node_map.h"
#include "dom_node_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_DomDocumentType construction:

CL_DomDocumentType::CL_DomDocumentType()
{
}

CL_DomDocumentType::CL_DomDocumentType(CL_DomDocument &doc)
: CL_DomNode(doc, DOCUMENT_TYPE_NODE)
{
}

CL_DomDocumentType::CL_DomDocumentType(const CL_SharedPtr<CL_DomNode_Generic> &impl) : CL_DomNode(impl)
{
}
	
CL_DomDocumentType::~CL_DomDocumentType()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_DomDocumentType attributes:

std::string CL_DomDocumentType::get_name() const
{
	if (impl) return impl->node_name;
	return std::string();
}
	
CL_DomNamedNodeMap CL_DomDocumentType::get_entities() const
{
	return CL_DomNamedNodeMap();
}
	
CL_DomNamedNodeMap CL_DomDocumentType::get_notations() const
{
	return CL_DomNamedNodeMap();
}

/////////////////////////////////////////////////////////////////////////////
// CL_DomDocumentType operations:

/////////////////////////////////////////////////////////////////////////////
// CL_DomDocumentType implementation:
