/*  $Id: dom_node_generic.h,v 1.10 2004/04/15 00:02:12 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_dom_node_generic
#define header_dom_node_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/System/sharedptr.h"
#include "API/Core/System/weakptr.h"
#include "API/Core/XML/dom_named_node_map.h"

#include <map>
#include <string>

class CL_DomDocument_Generic;

class CL_DomNode_Generic
{
//! Construction:
public:
	CL_DomNode_Generic()
	{
	}

	virtual ~CL_DomNode_Generic()
	{
	}

//! Attributes:
public:
	std::string node_name;

	std::string node_value;

	unsigned short node_type;

	CL_WeakPtr<CL_DomNode_Generic> parent;

	CL_SharedPtr<CL_DomNode_Generic> first_child;

	CL_SharedPtr<CL_DomNode_Generic> last_child;

	CL_SharedPtr<CL_DomNode_Generic> previous_sibling;

	CL_SharedPtr<CL_DomNode_Generic> next_sibling;

	CL_WeakPtr<CL_DomNode_Generic> owner_document;

	CL_DomNamedNodeMap attributes;

//! Operations:
public:

//! Implementation:
private:
};

#endif
