/*  $Id: dom_processing_instruction.cpp,v 1.7 2004/02/01 04:31:55 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Core/precomp.h"
#include "API/Core/XML/dom_processing_instruction.h"
#include "dom_node_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_DomProcessingInstruction construction:

CL_DomProcessingInstruction::CL_DomProcessingInstruction()
{
}

CL_DomProcessingInstruction::CL_DomProcessingInstruction(CL_DomDocument &doc, const std::string &target, const std::string &data)
: CL_DomNode(doc, PROCESSING_INSTRUCTION_NODE)
{
	impl->node_value = data;
}

CL_DomProcessingInstruction::CL_DomProcessingInstruction(const CL_SharedPtr<CL_DomNode_Generic> &impl) : CL_DomNode(impl)
{
}

CL_DomProcessingInstruction::~CL_DomProcessingInstruction()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_DomProcessingInstruction attributes:

std::string CL_DomProcessingInstruction::get_target() const
{
	return std::string();
}

std::string CL_DomProcessingInstruction::get_data() const
{
	return std::string();
}

void CL_DomProcessingInstruction::set_data(const std::string &data)
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_DomProcessingInstruction operations:

/////////////////////////////////////////////////////////////////////////////
// CL_DomProcessingInstruction implementation:
