/*  $Id: xml_tokenizer_generic.h,v 1.8 2004/02/01 04:31:55 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_xml_tokenizer_generic
#define header_xml_tokenizer_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/IOData/inputsource.h"

class CL_XMLTokenizer_Generic
{
//! Construction:
public:
	CL_XMLTokenizer_Generic() : input(0), delete_input(false), pos(0), size(0), eat_whitespace(true) { return; }

	~CL_XMLTokenizer_Generic() { if (delete_input) delete input; }

//! Attributes:
public:
	CL_InputSource *input;
	
	bool delete_input;

	std::string::size_type pos, size;

	std::string data;

	bool eat_whitespace;

//! Operations:
public:
	// used to get the line number when there is an error in the xml file
	int get_line_number()
	{
		int line = 1;
		std::string::size_type tmp_pos = 0;

		std::string::const_iterator it;
		for( it = data.begin(); it != data.end() && tmp_pos <= pos; ++it, tmp_pos++ )
		{
			if( (*it) == '\n' )
				line++;
		}
	
		return line;
	}

//! Implementation:
private:
};

#endif
