/*  $Id: core_iostream.cpp,v 1.2 2004/01/18 18:44:59 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Core/precomp.h"
#include <iostream>
#include "API/Core/Math/rect.h"
#include "API/Core/Math/size.h"
#include "API/Core/Math/point.h"

std::ostream& operator<<(std::ostream& s, const CL_Rect& rect)
{
	s << "["
	  << rect.left   << ", "
	  << rect.top    << ", "
	  << rect.right  << ", "
	  << rect.bottom << "]";
	return s;
}

std::ostream& operator<<(std::ostream& s, const CL_Rectf& rect)
{
	s << "["
	  << rect.left   << ", "
	  << rect.top    << ", "
	  << rect.right  << ", "
	  << rect.bottom << "]";
	return s;
}

std::ostream& operator<<(std::ostream& s, const CL_Point& point)
{
	s << "["
	  << point.x   << ", "
	  << point.y << "]";
	return s;
}

std::ostream& operator<<(std::ostream& s, const CL_Pointf& point)
{
	s << "["
	  << point.x   << ", "
	  << point.y << "]";
	return s;
}

std::ostream& operator<<(std::ostream& s, const CL_Size& size)
{
	s << size.width << "x" << size.height;
	return s;
}

std::ostream& operator<<(std::ostream& s, const CL_Sizef& size)
{
	s << size.width << "x" << size.height;
	return s;
}

// EOF //

