/*  $Id: outline_provider_bitmap.cpp,v 1.2 2004/04/05 09:51:58 sphair Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Display/display_precomp.h"
#include "API/Display/Collision/outline_provider_bitmap.h"
#include "API/Display/Collision/outline_accuracy.h"
#include "outline_provider_bitmap_generic.h"
#include "API/Display/Collision/outline_circle.h"

/////////////////////////////////////////////////////////////////////////////
// CL_OutlineProviderBitmap construction:

CL_OutlineProviderBitmap::CL_OutlineProviderBitmap(CL_PixelBuffer *pbuf, int alpha_limit )
{
	impl = new CL_OutlineProviderBitmap_Generic( pbuf, alpha_limit );
}

CL_OutlineProviderBitmap::~CL_OutlineProviderBitmap()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_OutlineProviderBitmap attributes:

std::vector<CL_Contour> CL_OutlineProviderBitmap::get_contours()
{
	return impl->contours;
}

int CL_OutlineProviderBitmap::get_width()
{
	return impl->width;
}

int CL_OutlineProviderBitmap::get_height()
{
	return impl->height;
}

