/*  $Id: outline_provider_file.cpp,v 1.2 2004/04/05 09:51:58 sphair Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Display/display_precomp.h"
#include "API/Display/Collision/outline_provider_file.h"
#include "API/Display/Collision/outline_circle.h"
#include "outline_provider_file_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_OutlineProviderFile Construction:

CL_OutlineProviderFile::CL_OutlineProviderFile(const std::string &filename, CL_InputSourceProvider *provider)
{
	impl = new CL_OutlineProviderFile_Generic( filename, provider );
}

CL_OutlineProviderFile::~CL_OutlineProviderFile()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_OutlineProviderFile Attributes:

std::vector<CL_Contour> CL_OutlineProviderFile::get_contours()
{
	return impl->contours;
}

int CL_OutlineProviderFile::get_width()
{
	return -1; //impl->width;
}

int CL_OutlineProviderFile::get_height()
{
	return -1; //impl->height;
}

