/*  $Id: outline_provider_file_generic.h,v 1.2 2004/04/05 09:51:58 sphair Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/
#ifndef header_outline_provider_file_generic
#define header_outline_provider_file_generic

#include "API/Display/Collision/contour.h"

#include <vector>
#include <string>

class CL_InputSourceProvider;

class CL_OutlineProviderFile_Generic
{
 public:
	CL_OutlineProviderFile_Generic(const std::string &filename, CL_InputSourceProvider *provider);
	~CL_OutlineProviderFile_Generic();

	std::vector<CL_Contour> contours;
	int width, height;

 private:
	void load(const std::string &filename);	
	CL_InputSourceProvider *provider;
};

#endif
