/*  $Id: dc_buffer_generic.h,v 1.9 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_dc_buffer_generic
#define header_dc_buffer_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <windows.h>
#include "API/Display/pixel_buffer.h"
#include "Display/pixel_buffer_generic.h"

class CL_DeviceContextBuffer_Generic : public CL_PixelBuffer_Generic
{
//! Construction:
public:
	//: Construct a pixelbuffer using the pixel format of the passed device context.
	CL_DeviceContextBuffer_Generic(HDC reference_dc, int width, int height, bool monocrome_alpha);

	~CL_DeviceContextBuffer_Generic();

//! Attributes:
public:
	HDC get_dc() { return memory_dc; }

//! Operations:
public:
	//: Returns a pointer to the beginning of the pixel buffer. Pointer
	//: is only valid inside a lock/unlock session.
	virtual void *get_data();

	//: Reference counted lock function.
	virtual void perform_lock();

	//: Reference counted unlock function.
	virtual void perform_unlock();

//! Implementation:
private:
	HDC ref_dc;

	HDC memory_dc;

	BITMAPINFO bitmap_info;

	HBITMAP bitmap, orig_bitmap;

	unsigned char *data;

	bool first_lock;
};

#endif
