/*  $Id: display_window_description_generic.h,v 1.6 2003/12/27 17:14:16 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_display_window_description_generic
#define header_display_window_description_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <string>
#include "API/Core/Math/rect.h"

class CL_DisplayWindowDescription_Generic
{
//! Construction:
public:
	CL_DisplayWindowDescription_Generic() : ref_count(0)
	{
		title = "Untitled clanlib window";
		position = CL_Rect(-1, -1, 639, 479);
		fullscreen = false;
		flipping_buffers = 2;
		allow_resize = false;
		refresh_rate = 0;
		bpp = 0;
		#ifdef WIN32
		layered = false;
		#endif
	}

	virtual ~CL_DisplayWindowDescription_Generic() { return; }

//! Attributes:
public:
	int ref_count;

	std::string title;

	CL_Rect position;

	bool fullscreen;

	bool allow_resize;

	int flipping_buffers;
	
	int bpp;

	int refresh_rate;
	
#ifdef WIN32
	bool layered;
#endif

//! Operations:
public:
	void add_ref() { ref_count++; }

	void release_ref() { ref_count--; if (ref_count == 0) delete this; }
};

#endif
