/*  $Id: font_generic.h,v 1.31 2004/03/08 15:37:12 sphair Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_font_generic
#define header_font_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Display/sprite.h"
#include "API/Core/Math/origin.h"
#include "API/Display/font.h"
#include "API/Core/Math/point.h"
#include "API/Core/System/clonable.h"
#include <string>

class CL_GraphicContext;
class CL_GlyphBuffer;
class CL_Size;
class CL_Rect;
class CL_Font_Target;

class CL_Font_Generic : public CL_Clonable
{
//! Construction:
public:
	CL_Font_Generic(); 

	CL_Font_Generic(const CL_Font_Generic &copy);
	
	virtual ~CL_Font_Generic();

//! Attributes:
public:
	//: Alters the percieved width of each glyph
	int width_offset;
	
	//: Alters the percieved height of each line
	int height_offset;
	
	//: Alignment
	CL_Origin trans_origin;

	int trans_x;
	
	int trans_y;
	
	//: A list of characters (other than the newline character) that seperate words
	std::string delims;

	CL_SharedPtr<CL_Font_Target> target;
	
//! Operations:
public:
	virtual CL_Clonable *clone() const { return new CL_Font_Generic(*this); }

//! Implementation
private:
};

#endif
