/*  $Id: input_buffer_generic.h,v 1.7 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_input_buffer_generic
#define header_input_buffer_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <queue>
#include "API/Display/input_event.h"
#include "API/signals.h"

class CL_InputBuffer_Generic
{
//! Construction:
public:
	CL_InputBuffer_Generic() : ref_count(0) { return; }

//! Attributes:
public:
	std::queue<CL_InputEvent> buffer;

	CL_SlotContainer slots;

//! Operations:
public:
	void add_ref() { ref_count++; }

	void release_ref() { ref_count--; if (ref_count == 0) delete this; }

	void on_key_down(const CL_InputEvent &key) { buffer.push(key); }

	void on_key_up(const CL_InputEvent &key) { buffer.push(key); }

//! Implementation:
private:
	int ref_count;
};

#endif
