/*  $Id: input_context_generic.h,v 1.9 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_input_context_generic
#define header_input_context_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <vector>
#include "API/Display/input_device.h"

class CL_InputEvent;

//: Input events interface.
class CL_InputContext_Generic
{
//! Construction:
public:
	CL_InputContext_Generic();

	~CL_InputContext_Generic();

//! Attributes:
public:
	std::vector<CL_InputDevice> keyboards;

	std::vector<CL_InputDevice> mice;

	std::vector<CL_InputDevice> joysticks;

//! Operations:
public:
	void add_ref();

	void release_ref();

	//: Removes all devices from this input context.
	void clear();

	//: Adds a new keyboard to the input context.
	void add_keyboard(const CL_InputDevice &keyboard);

	//: Adds a new mouse to the input context.
	void add_mouse(const CL_InputDevice &mouse);

	//: Adds a new joystick to the input context.
	void add_joystick(const CL_InputDevice &joystick);

//! Implementation:
private:
	int ref_count;
};

#endif
