/*  $Id: resourcedata_sprite.h,v 1.9 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_resourcedata_sprite
#define header_resourcedata_sprite

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/Resources/resourcedata.h"
#include "API/Core/Resources/resource.h"
#include "API/Display/sprite.h"
#include "resourcedata_sprite_description.h"

class CL_ResourceData_Sprite : public CL_ResourceData_SpriteDescription
{
//! Construction:
public:
	CL_ResourceData_Sprite(CL_Resource &resource);
	
	virtual ~CL_ResourceData_Sprite();
	
//! Attributes:
public:
	CL_Sprite &get_sprite() { return sprite; }

//! Implementation:
private:
	void on_load();
	
	void on_unload();

	CL_Sprite sprite;
};

#endif
