/*  $Id: resourcedata_sprite_description.h,v 1.5 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_resourcedata_sprite_description
#define header_resourcedata_sprite_description

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/Resources/resourcedata.h"
#include "API/Core/Resources/resource.h"
#include "API/Display/sprite_description.h"

class CL_ResourceData_SpriteDescription : public CL_ResourceData
{
//! Construction:
public:
	CL_ResourceData_SpriteDescription(CL_Resource &resource, const std::string &type = "sprite_description");
	
	virtual ~CL_ResourceData_SpriteDescription();
	
//! Attributes:
public:

//! Operations:
public:
	//: Loads a sprite description based on the resource description.
	CL_SpriteDescription load_description();

//! Implementation:
private:
	CL_PixelBuffer *load_image(const std::string &filename);

	void add_images(CL_SpriteDescription &desc, CL_Resource &resource);
};

#endif
