/*  $Id: resourcedata_surface.h,v 1.7 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_resourcedata_surface
#define header_resourcedata_surface

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/Resources/resourcedata.h"
#include "API/Core/Resources/resource.h"
#include "API/Display/surface.h"

class CL_ResourceData_Surface : public CL_ResourceData
{
//! Construction:
public:
	CL_ResourceData_Surface(CL_Resource &resource);
	
	virtual ~CL_ResourceData_Surface();
	
//! Attributes:
public:
	CL_Surface &get_surface() { return surface; }

//! Implementation:
private:
	void on_load();
	
	void on_unload();

	CL_Surface surface;
};

#endif
