/*  $Id: sprite_description_generic.h,v 1.12 2004/02/18 14:32:15 sphair Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_sprite_description_generic
#define header_sprite_description_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Display/sprite_description.h"

class CL_SpriteDescription_Generic
{
//! Construction:
public:
	CL_SpriteDescription_Generic() : ref_count(0), flag(CL_Surface::flag_none) { return; }

//! Attributes:
public:
	int ref_count;

	int flag;

	std::list<CL_SpriteDescription::FramePair> frames;

	std::list<CL_PixelBuffer *> delete_providers;

//! Operations:
public:
	int add_ref() { return ++ref_count; }

	int release_ref() { return --ref_count; }
};

#endif
