/*  $Id: sprite_packer_generic.h,v 1.12 2003/10/14 15:52:12 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_sprite_packer_generic
#define header_sprite_packer_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Core/Math/size.h"
#include "API/Core/Math/rect.h"
#include "API/Display/sprite_description.h"
#include "API/Display/surface.h"
#include "API/Display/sprite_packer.h"

// Stuff to improve:
// - Sort the textures after size before inserting - might do wonders

class CL_SpritePacker_Generic
{
//! Construction:
public:
	CL_SpritePacker_Generic(const CL_SpriteDescription &description);

	class Node
	{
	public:
		Node();
		Node(const CL_Rect &rect);
		~Node();

		Node *insert(CL_SpriteDescription::FramePair image);
		void clear();
		
		Node *child[2];
		CL_Rect rect;
	    
	    CL_PixelBuffer *image;
	    CL_Rect image_rect;
	};

//! Attributes:
public:
	const CL_SpriteDescription &description;

	std::vector<CL_Size> texture_sizes;
	std::list<CL_SpritePacker::TexturePair> packed_frames;
};

#endif

