/*  $Id: gl_state.h,v 1.18 2004/04/22 21:45:23 harry Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_gl_state
#define header_gl_state

#if _MSC_VER > 1000
#pragma once
#endif

#ifdef WIN32
#include <windows.h>
#endif

#include "API/GL/opengl.h"
#include "API/Display/blend_func.h"
#include "API/Display/gradient.h"
#include "API/Core/Math/point.h"

#include "fillmode.h"

class CL_GLState
{
//! Construction:
public:
	CL_GLState() {};

//! Attributes:
public:
	CLfloat color[4];

	int texture_handle;

	CL_BlendFunc blendfunc[2];

	CL_FillMode fillmode;
};

#endif
