/*  $Id: opengl_surface.cpp,v 1.5 2004/02/18 14:32:15 sphair Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Display/display_precomp.h"
#include "API/GL/opengl_surface.h"
#include "API/GL/opengl_wrap.h"
#include "surface_target_opengl.h"

#define gl_target ((CL_Surface_Target_OpenGL *) impl->target)

/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLSurface construction:

CL_OpenGLSurface::CL_OpenGLSurface() : CL_Surface()
{
}
	
CL_OpenGLSurface::CL_OpenGLSurface(const CL_Surface &copy) : CL_Surface(copy)
{
}
	
CL_OpenGLSurface::CL_OpenGLSurface(
	CL_PixelBuffer *provider,
	bool delete_provider,
	int flag) : CL_Surface(provider, delete_provider, flag)
{
}

CL_OpenGLSurface::CL_OpenGLSurface(
	const std::string &resource_id,
	CL_ResourceManager *manager) : CL_Surface(resource_id, manager)
{
}

CL_OpenGLSurface::CL_OpenGLSurface(
	const std::string &filename,
	int flag) : CL_Surface(filename, flag)
{
}

CL_OpenGLSurface::~CL_OpenGLSurface()
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLSurface attributes:

/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLSurface operations:

void CL_OpenGLSurface::bind()
{
	clBindTexture(CL_TEXTURE_2D, gl_target->handle);
}

/////////////////////////////////////////////////////////////////////////////
// CL_OpenGLSurface implementation:
