/*  $Id: opengl_target.h,v 1.11 2004/02/18 14:32:15 sphair Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_opengl_target
#define header_opengl_target

#if _MSC_VER > 1000
#pragma once
#endif

#include "Display/display_target.h"

class CL_OpenGLTarget : public CL_DisplayTarget
{
//! Construction:
public:

//! Attributes:
public:

//! Operations:
public:
	virtual CL_DisplayWindow_Generic *create_window();

	virtual CL_Surface_Target *create_surface(
		CL_PixelBuffer *provider,
		bool delete_provider,
		int flag);

	virtual CL_Canvas_Generic *create_canvas();

	virtual CL_Font_Target* create_system_font_target(
		CL_Font_Generic *attributes,
		const std::string &font_name,
		const std::string &letters,
		int height,
		int width,
		bool bold,
		bool italic,
		bool underline,
		bool strikeout);

	virtual bool enable_packer();

//! Implementation:
private:
};

#endif
