/*  $Id: opengl_window_description_generic.h,v 1.4 2004/01/12 13:31:29 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_opengl_window_description_generic
#define header_opengl_window_description_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "Display/display_window_description_generic.h"

class CL_OpenGLWindowDescription_Generic : public CL_DisplayWindowDescription_Generic
{
//! Construction:
public:
	CL_OpenGLWindowDescription_Generic()
	{
		rgba = true;
		doublebuffer = true;
		stereo = false;
		buffer_size = 16;
		level = 0;
		aux_buffers = 0;
		red_size = 4;
		green_size = 4;
		blue_size = 4;
		alpha_size = 4;
		depth_size = 16;
		stencil_size = 8;
		accum_red_size = 0;
		accum_green_size = 0;
		accum_blue_size = 0;
		accum_alpha_size = 0;
	}

//! Attributes:
public:

	bool rgba;
	bool doublebuffer;
	bool stereo;
	int buffer_size;
	int level;
	int aux_buffers;
	int red_size;
	int green_size;
	int blue_size;
	int alpha_size;
	int depth_size;
	int stencil_size;
	int accum_red_size;
	int accum_green_size;
	int accum_blue_size;
	int accum_alpha_size;
};

#endif
