/*  $Id: pixel_buffer_opengl_frame.h,v 1.5 2003/12/16 16:47:03 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_pixelbuffer_opengl_frame
#define header_pixelbuffer_opengl_frame

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Display/graphic_context.h"
#include "Display/pixel_buffer_generic.h"
#ifdef WIN32
#include <windows.h>
#endif
#include "API/GL/opengl.h"

//: Pixel data access to a frame buffer.
class CL_PixelBuffer_OpenGL_Frame : public CL_PixelBuffer_Generic
{
//! Construction:
public:
	CL_PixelBuffer_OpenGL_Frame(CLenum frame, CL_GraphicContext &gc);

	~CL_PixelBuffer_OpenGL_Frame();

//! Operations:
public:
	virtual void *get_data();

	virtual void perform_lock();

	virtual void perform_unlock();

//! Implementation:
private:
	CLenum frame;

	CL_GraphicContext gc;

	char *data;
};

#endif
