/*  $Id: component_manager_generic.h,v 1.35 2004/03/11 12:59:41 mbn Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef header_component_manager_generic
#define header_component_manager_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <string>
#include <stack>
#include <vector>
#include <stdio.h>

#include "API/GUI/component_manager.h"
#include "API/GUI/stylemanager.h"
#include "API/GUI/component.h"
#include "API/Core/XML/dom_element.h"
#include "API/Core/XML/dom_document.h"

class CL_InputSource;

class CL_ComponentManager_Generic
{
//! Construction:
public:
	CL_ComponentManager_Generic(
		const std::string &resource_id,
		CL_ResourceManager *resources,
		CL_Component *parent,
		CL_StyleManager *style);

	CL_ComponentManager_Generic(
		const std::string &filename,
		CL_Component *parent,
		CL_StyleManager *style,
		CL_InputSourceProvider *input_provider,
		bool delete_provider);

	CL_ComponentManager_Generic(
		const CL_DomDocument &document,
		const CL_DomElement &element,
		CL_Component *parent,
		CL_StyleManager *style);
		
	~CL_ComponentManager_Generic();

//! Attributes:
public:
	CL_Component *get_component(const std::string &component_id) const;

	CL_StyleManager *get_style_manager() const { return style_manager; }

//! Operations:
public:

//! Implementation:
private:
	void parse_components(const CL_DomElement &componentsElement, CL_Component *parent, bool root_level);

	CL_StyleManager *style_manager;
	
	CL_Component *parent;

	CL_DomDocument document;

	std::map<std::string, CL_Component *> component_map;

	std::vector<CL_Component *> root_components;
};

#endif
