/*  $Id: menu_item_generic.h,v 1.3 2003/12/15 19:44:15 harry Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_label_generic
#define header_label_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/GUI/menu_item.h"
#include "API/Display/surface.h"

class CL_MenuItem_Generic
{
//! Construction:
public:
	CL_MenuItem_Generic(
		CL_MenuItem *self,	
		const std::string &text);

//! Attributes:
public:
	bool toggling;
	bool selected;
	bool use_icon;

	std::string text;

//! Implementation:
private:
	void on_set_options(const CL_DomElement &options);
	void on_mouse_down(const CL_InputEvent &event);

	CL_MenuItem *menu_item;

	CL_SlotContainer slots;
};  

#endif
