/*  $Id: stylemanager.cpp,v 1.5 2003/07/20 22:23:22 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "precomp.h"
#include "API/GUI/component_manager.h"
#include "API/GUI/stylemanager.h"

/////////////////////////////////////////////////////////////////////////////
// CL_StyleManager_Generic:

class CL_StyleManager_Generic
{
public:
	CL_ResourceManager *resources;
};

/////////////////////////////////////////////////////////////////////////////
// CL_StyleManager construction:

CL_StyleManager::CL_StyleManager(CL_ResourceManager *resources)
: impl(new CL_StyleManager_Generic)
{
	impl->resources = resources;
}

CL_StyleManager::~CL_StyleManager()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_StyleManager attributes:

CL_ResourceManager *CL_StyleManager::get_resources()
{
	return impl->resources;
}

/////////////////////////////////////////////////////////////////////////////
// CL_StyleManager overridables:

CL_Component *CL_StyleManager::create_component(
	const std::string &type,
	CL_Component *parent)
{
	return CL_ComponentType::create_component(type, parent, this);
}
