/*  $Id: treeview_generic.h,v 1.18 2004/01/08 19:46:42 sphair Exp $
	
	ClanGUI, copyrights by various people. Have a look in the CREDITS file.
	
	This sourcecode is distributed using the Library GNU Public Licence,
	version 2 or (at your option) any later version. Please read LICENSE
	for details.
*/

#ifndef header_treeview_generic
#define header_treeview_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/GUI/treeview.h"

class CL_TreeView_Generic
{
//! Construction:
public:
	CL_TreeView_Generic(CL_TreeView *self);
	~CL_TreeView_Generic();

//! Attributes:
public:
	int get_column_count() const;
	int get_column_width(int index) const;
	const std::string &get_column_name(int index) const;

	bool show_root_decoration;
	bool show_header;

//! Operations:
public:
	int add_column(const std::string &name, int width);
		
//! Signals:
public:
	CL_Signal_v2<CL_TreeNode *, CL_Point &> sig_paint_node;
	CL_Signal_v1<const CL_TreeNode &> sig_selection_changed;
	CL_Signal_v1<const CL_TreeNode &> sig_item_clicked;
	CL_Signal_v1<const CL_TreeNode &> sig_item_added;
	CL_Signal_v1<const CL_TreeNode &> sig_item_removed;
	CL_Signal_v1<const CL_TreeNode &> sig_item_expanded;
	CL_Signal_v1<const CL_TreeNode &> sig_item_collapsed;
	CL_Signal_v1<int> sig_column_added;
	CL_Signal_v1<int> sig_column_removed;
	CL_Signal_v0 sig_clear;

//! Callbacks:
private:
	void on_paint_children(CL_SlotParent_v0 &super);

//! Implementation:
private:
	struct Column
	{
		std::string name;
		int original_width;
		int width;
	};
	std::vector<Column> columns;

	CL_Slot slot_paint_children;

	CL_TreeView *treeview;
};

#endif
