/*  $Id: netobject_client.cpp,v 1.6 2003/07/20 22:34:39 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "API/Network/NetObjects/netobject_client.h"
#include "API/Network/NetObjects/netobject_controller.h"
#include "netobject_client_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_NetObject_Client construction:

CL_NetObject_Client::CL_NetObject_Client(int obj_id, const CL_NetComputer &server, CL_NetObject_Controller_Generic *controller)
: impl(0)
{
	impl = new CL_NetObject_Client_Generic(obj_id, server, controller);
	impl->add_ref();
}

CL_NetObject_Client::CL_NetObject_Client(const CL_NetObject_Client &copy)
: impl(copy.impl)
{
	if (impl) impl->add_ref();
}

CL_NetObject_Client::~CL_NetObject_Client()
{
	if (impl) impl->release_ref();
}

/////////////////////////////////////////////////////////////////////////////
// CL_NetObject_Client attributes:

int CL_NetObject_Client::get_obj_id() const
{
	return impl->obj_id;
}

CL_NetComputer &CL_NetObject_Client::get_server() const
{
	return impl->server;
}

/////////////////////////////////////////////////////////////////////////////
// CL_NetObject_Client operations:

void CL_NetObject_Client::send(int msg_type, const CL_NetPacket &message)
{
	impl->send(msg_type, message);
}

/////////////////////////////////////////////////////////////////////////////
// CL_NetObject_Client signals:

CL_Signal_v1<CL_NetPacket &> &CL_NetObject_Client::sig_received_message(int msg_type)
{
	return impl->sig_received_message[msg_type];
}

/////////////////////////////////////////////////////////////////////////////
// CL_NetObject_Client implementation:
