/*  $Id: netobject_controller.cpp,v 1.6 2003/07/20 22:34:39 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "API/Network/NetObjects/netobject_controller.h"
#include "netobject_controller_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_NetObjectController construction:

CL_NetObject_Controller::CL_NetObject_Controller(CL_NetSession *netsession, const std::string &channel)
: impl(0)
{
	impl = new CL_NetObject_Controller_Generic(netsession, channel);
}

CL_NetObject_Controller::CL_NetObject_Controller(const CL_NetObject_Controller &copy)
: impl(copy.impl)
{
	if (impl) impl->add_ref();
}

CL_NetObject_Controller::~CL_NetObject_Controller()
{
	if (impl) impl->release_ref();
}

/////////////////////////////////////////////////////////////////////////////
// CL_NetObjectController attributes:

/////////////////////////////////////////////////////////////////////////////
// CL_NetObject_Controller operations:

CL_NetObject_Controller &CL_NetObject_Controller::operator =(const CL_NetObject_Controller &copy)
{
	if (impl) impl->release_ref();
	impl = copy.impl;
	if (impl) impl->add_ref();
	return *this;
}

/////////////////////////////////////////////////////////////////////////////
// CL_NetObject_Controller signals:

CL_Signal_v3<CL_NetObject_Client &, int, CL_NetPacket &> &CL_NetObject_Controller::sig_create_object()
{
	return impl->sig_create_object;
}

/////////////////////////////////////////////////////////////////////////////
// CL_NetObject_Controller implementation:
