/*  $Id: netobject_server_generic.h,v 1.9 2003/10/14 15:52:13 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_netobject_server_generic
#define header_netobject_server_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/signals.h"
#include <map>
class CL_NetComputer;
class CL_NetPacket;
class CL_NetGroup;
class CL_NetObject_Controller_Generic;

class CL_NetObject_Server_Generic
{
//! Construction:
public:
	CL_NetObject_Server_Generic(CL_NetObject_Controller_Generic *controller);

	~CL_NetObject_Server_Generic();

//! Attributes:
public:
	int obj_id;

	CL_NetObject_Controller_Generic *controller;

	std::map< int, CL_Signal_v2<CL_NetComputer &, CL_NetPacket &> > sig_received_message;

//! Operations:
public:
	void receive(int msg_type, CL_NetComputer &from, CL_NetPacket &packet);

	void send(CL_NetGroup &group, int msg_type, const CL_NetPacket &message);
	void send(CL_NetComputer &computer, int msg_type, const CL_NetPacket &message);

	int add_ref() { return ++ref_count; }

	int release_ref()
	{
		ref_count--;
		if (ref_count == 0) { delete this; return 0; }
		return ref_count;
	}

//! Implementation:
private:
	int ref_count;
};

#endif
