/*  $Id: netgroup.cpp,v 1.5 2004/01/26 16:14:48 sphair Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "API/Network/NetSession/netgroup.h"
#include "API/Network/NetSession/netcomputer.h"

/////////////////////////////////////////////////////////////////////////////
// CL_NetGroup construction:

CL_NetGroup::CL_NetGroup()
{
}

CL_NetGroup::CL_NetGroup(const CL_NetComputer &computer)
{
	push_back(computer);
}

CL_NetGroup::CL_NetGroup(const std::list<CL_NetComputer> &group) : std::list<CL_NetComputer>(group)
{
}

/////////////////////////////////////////////////////////////////////////////
// CL_NetGroup operations:

void CL_NetGroup::send(const std::string &packet_channel, const CL_NetPacket &packet, bool reliable)
{
	for (iterator it = begin(); it != end(); it++)
	{
		(*it).send(packet_channel, packet, reliable);
	}
}

void CL_NetGroup::disconnect()
{
	for (iterator it = begin(); it != end(); it++)
	{
		(*it).disconnect();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CL_NetGroup implementation:
