/*  $Id: event_trigger_socket.h,v 1.5 2003/10/14 15:52:13 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_event_trigger_socket
#define header_event_trigger_socket

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/signals.h"
#include "API/Core/System/event_trigger.h"
#include <map>

class CL_SocketSelect;
class CL_Socket_Generic;

class CL_EventTrigger_Socket : public CL_EventTrigger
{
public:
	enum Type
	{
		read,
		write,
		exception
	};

//! Construction:
public:
	CL_EventTrigger_Socket(CL_Socket_Generic *sock, Type type);

	~CL_EventTrigger_Socket();

//! Attributes:
public:
	CL_Socket_Generic *get_socket() const { return sock; }

	Type get_type() const { return type; }

	static CL_SocketSelect *socket_select;

//! Operations:
public:
	void start_listen();

//! Implementation:
private:

	CL_Socket_Generic *sock;
	Type type;
};

#endif
