/*  $Id: sound.cpp,v 1.3 2003/07/20 22:21:27 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Sound/precomp.h"
#include "API/Sound/sound.h"
#include "API/Sound/soundoutput.h"

/////////////////////////////////////////////////////////////////////////////
// CL_SoundOutput accessors:

static CL_SoundOutput *cl_current_output = 0;

const std::string &CL_Sound::get_name()
{
	return get_current_output()->get_name();
}

int CL_Sound::get_mixing_frequency()
{
	return get_current_output()->get_mixing_frequency();
}

CL_SoundOutput *CL_Sound::get_current_output()
{
	return cl_current_output;
}

void CL_Sound::select_output(CL_SoundOutput *output)
{
	cl_current_output = output;
}
