/*  $Id: soundbuffer_generic.h,v 1.6 2004/02/01 20:28:56 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#ifndef header_soundbuffer_generic
#define header_soundbuffer_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include <vector>
#include "API/Core/System/mutex.h"

class CL_SoundProvider;
class CL_SoundFilter;

class CL_SoundBuffer_Generic
{
//! Construction:
public:
	CL_SoundBuffer_Generic();
	
	virtual ~CL_SoundBuffer_Generic();

//! Attributes:
public:
	CL_SoundProvider *provider;
	
	bool delete_provider;
	
	float volume;
	
	float pan;

	std::vector<CL_SoundFilter *> filters;
	
	std::vector<bool> delete_filters;
	
	mutable CL_Mutex mutex;
	
//! Operations:
public:
	
//! Implementation:
private:
};

#endif
