/*  $Id: soundoutput_description.cpp,v 1.2 2003/07/20 22:21:27 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Sound/precomp.h"
#include "API/Sound/soundoutput_description.h"

/////////////////////////////////////////////////////////////////////////////
// CL_SoundOutput_Description_Generic:

class CL_SoundOutput_Description_Generic
{
//! Attributes:
public:
	int mixing_frequency;
};

/////////////////////////////////////////////////////////////////////////////
// CL_SoundOutput_Description construction:

CL_SoundOutput_Description::CL_SoundOutput_Description() : impl(new CL_SoundOutput_Description_Generic)
{
	impl->mixing_frequency = 44100;
}

CL_SoundOutput_Description::CL_SoundOutput_Description(const CL_SoundOutput_Description &copy) : impl(new CL_SoundOutput_Description_Generic)
{
	*impl = *copy.impl;
}

CL_SoundOutput_Description::~CL_SoundOutput_Description()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_SoundOutput_Description attributes:

int CL_SoundOutput_Description::get_mixing_frequency() const
{
	return impl->mixing_frequency;
}

/////////////////////////////////////////////////////////////////////////////
// CL_SoundOutput_Description operations:

CL_SoundOutput_Description &CL_SoundOutput_Description::operator =(const CL_SoundOutput_Description &copy)
{
	*impl = *copy.impl;
	return *this;
}

void CL_SoundOutput_Description::set_mixing_frequency(int frequency)
{
}

// CL_SoundOutput_Description implementation:
/////////////////////////////////////////////////////////////////////////////
